VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Setcursr sample from BlackBeltVB.com"
   ClientHeight    =   1815
   ClientLeft      =   1710
   ClientTop       =   1545
   ClientWidth     =   6060
   Height          =   2220
   Left            =   1650
   LinkTopic       =   "Form1"
   MousePointer    =   99  'Custom
   ScaleHeight     =   1815
   ScaleWidth      =   6060
   Top             =   1200
   Width           =   6180
   Begin VB.Label Label1 
      Caption         =   $"Setcursr.frx":0000
      Enabled         =   0   'False
      Height          =   1395
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False


Option Explicit
'
' Setcursr sample from BlackBeltVB.com
' http://blackbeltvb.com
'
' Written by Matt Hart
' Copyright 1999 by Matt Hart
' 
' This software is FREEWARE. You may use it as you see fit for 
' your own projects but you may not re-sell the original or the 
' source code. Do not copy this sample to a collection, such as
' a CD-ROM archive. You may link directly to the original sample
' using "http://blackbeltvb.com/setcursr.htm"
' 
' No warranty express or implied, is given as to the use of this
' program. Use at your own risk.
'
' This shows how to load a cursor from a file and
' use it with your application.  It's not perfect,
' but it'll work for you.  I'd like to get the MouseIcon
' property to accept the loaded cursor.  Perhaps I
' can figure that out in the future.  This might also work
' better if you did the SetCursor API call and then used
' a message hook control to discard the SetCursor that VB
' keeps doing on every MouseMove event.  You *can* do a
' SetCursor in the MouseMove event, and that works - but it's
' a bit kludgy, imho.

Private Declare Function CopyCursor Lib "user32" Alias "CopyIcon" (ByVal hcur As Long) As Long
Private Declare Function GetCursor Lib "user32" () As Long
Private Declare Function LoadDefaultCursor Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorID As Long) As Long
Private Declare Function LoadCursorFromFile Lib "user32" Alias "LoadCursorFromFileA" (ByVal lpFileName As String) As Long
Private Declare Function DestroyCursor Lib "user32" (ByVal hCursor As Long) As Long
Private Declare Function SetCursor Lib "user32" (ByVal hCursor As Long) As Long
Private Declare Function SetSystemCursor Lib "user32" (ByVal hcur As Long, ByVal id As Long) As Long
Private Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long

Private Const OCR_NORMAL = 32512
Private Const OCR_IBEAM = 32513
Private Const OCR_WAIT = 32514
Private Const OCR_CROSS = 32515
Private Const OCR_UP = 32516
Private Const OCR_SIZE = 32640
Private Const OCR_ICON = 32641
Private Const OCR_SIZENWSE = 32642
Private Const OCR_SIZENESW = 32643
Private Const OCR_SIZEWE = 32644
Private Const OCR_SIZENS = 32645
Private Const OCR_SIZEALL = 32646
Private Const OCR_ICOCUR = 32647
Private Const OCR_NO = 32648 ' not in win3.1

' Standard Cursor IDs
Private Const IDC_ARROW = 32512&
Private Const IDC_IBEAM = 32513&
Private Const IDC_WAIT = 32514&
Private Const IDC_CROSS = 32515&
Private Const IDC_UPARROW = 32516&
Private Const IDC_SIZE = 32640&
Private Const IDC_ICON = 32641&
Private Const IDC_SIZENWSE = 32642&
Private Const IDC_SIZENESW = 32643&
Private Const IDC_SIZEWE = 32644&
Private Const IDC_SIZENS = 32645&
Private Const IDC_SIZEALL = 32646&
Private Const IDC_NO = 32648&
Private Const IDC_APPSTARTING = 32650&

Dim hCursor As Long, hOldCursor As Long

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If hCursor = 0 Then
        Dim lRet As Long, a As String, hInstance As Long, hImage As Long
        a = "c:\windows\cursors\" & Dir$("c:\windows\cursors\*.ani")
        hCursor = LoadCursorFromFile(a)
        If hCursor Then
            lRet = GetCursor()
            hOldCursor = CopyCursor(lRet)
            lRet = SetSystemCursor(hCursor, OCR_NORMAL)
        End If
        Label1.Enabled = True
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim lRet As Long
    If hCursor Then
        lRet = SetSystemCursor(hOldCursor, OCR_NORMAL)
    End If
End Sub
